/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Contents of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log


Revision 243 - (show annotations)
Thu Mar 24 16:40:46 2011 UTC (13 years, 1 month ago) by dpavlin
File MIME type: application/x-sh
File size: 5812 byte(s)
remount rootfs before start to fix debian upgrades
1 #! /bin/sh
2 ### BEGIN INIT INFO
3 # Provides: lxc-watchdog
4 # Required-Start: $remote_fs $named $network $time
5 # Required-Stop: $remote_fs $named $network
6 # Required-Start:
7 # Required-Stop:
8 # Default-Start: 2 3 4 5
9 # Default-Stop: 0 1 6
10 # Short-Description: Manage Linux Containers startup/shutdown
11 # Description: Uses clever inotify hack to monitor container's
12 # halt/reboot events watching /var/run/utmp
13 ### END INIT INFO
14
15 # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16 #
17 # based on Tony Risinger post to lxc-users mailing list
18 # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19 #
20 # Install with:
21 # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22 # update-rc.d lxc-watchdog defaults
23
24
25 which inotifywait >/dev/null || apt-get install inotify-tools
26
27
28 lxc_exists() {
29 name=$1
30
31 if [ ! -e /var/lib/lxc/$name/config ] ; then
32 echo "Usage: $0 name"
33 lxc_status
34 exit 1
35 fi
36 }
37
38
39 lxc_rootfs() {
40 grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41 }
42
43 lxc_hostname() {
44 inside=`cat $(lxc_rootfs $1)/etc/hostname`
45 config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46 echo "$config [$inside]";
47 }
48
49 lxc_ip() {
50 ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51 grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52 head -1 | \
53 sed -e 's/ *//g' -e 's/\/.*$//'
54 }
55
56 lxc_status() {
57 ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58 boot="-"
59 test -s /var/lib/lxc/$name/on_boot && boot="boot"
60 echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61 done ) | column -t
62 }
63
64
65 cleanup_init_scripts() {
66 rootfs=$(lxc_rootfs $1)
67
68 ls \
69 $rootfs/etc/rc?.d/*checkroot* \
70 $rootfs/etc/rc?.d/*umountfs \
71 $rootfs/etc/rc?.d/*umountroot \
72 $rootfs/etc/rc?.d/*hwclock* \
73 $rootfs/etc/rc?.d/*udev* \
74 $rootfs/etc/rc?.d/*checkfs* \
75 2>/dev/null | xargs -i rm -v {}
76
77 echo $1 > $rootfs/etc/hostname
78 grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79 }
80
81
82 setup_inittab() {
83 rootfs=$(lxc_rootfs $1)
84 remove=$2
85 add=$3
86
87 # let container respond to kill -SIGPWR
88 inittab=$rootfs/etc/inittab
89 if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
90 grep -v "$remove" ${inittab} > ${inittab}.new
91 echo $add >> ${inittab}.new
92 mv ${inittab}.new ${inittab}
93 echo "$inittab modified with $add"
94 fi
95 }
96
97
98 lxc_log() {
99 echo `date +%Y-%m-%dT%H:%M:%S` $*
100 }
101
102
103 lxc_kill() {
104 name=$1
105 sig=$2
106
107 init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
108 if [ -z "$init_pid" ] ; then
109 lxc-info -n $name
110 exit 1
111 fi
112 lxc_log "$name kill $sig $init_pid"
113 /bin/kill $sig $init_pid
114 }
115
116 lxc_stop() {
117 lxc_log "$name stop"
118 lxc_kill $name -SIGPWR
119 lxc-wait -n $name -s STOPPED
120 lxc_log "$name stoped"
121 # rm -f /var/lib/lxc/${name}/on_boot
122 }
123
124
125 lxc_start() {
126 name=$1
127 rootfs=$(lxc_rootfs $1)
128
129 if [ ! -e $rootfs ] ; then
130 echo "ERROR $name rootfs $rootfs not found"
131 return
132 fi
133
134 if ! lxc-info -n $name | grep RUNNING ; then
135 lxc_log "$name start"
136 mount $rootfs -o remount,rw # fix debian upgrade which remounts dir ro
137 lxc-start -n $name -o /tmp/${name}.log -d
138 lxc-wait -n $name -s RUNNING
139 lxc-info -n $name
140 test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
141 fi
142 }
143
144 lxc_watchdog() {
145 name=$1
146 rootfs=$(lxc_rootfs $1)
147
148 while true; do
149 vps_utmp=${rootfs}/var/run/utmp
150 tasks=`wc -l < /cgroup/${name}/tasks`
151 stop_on=1 # init
152 sulogins=`lxc-ps --name backuppc | grep sulogin | wc -l`
153 if [ "$sulogins" -gt 0 ] ; then
154 stop_on=`expr $stop_on + $sulogins`
155 fi
156
157 test -z "$tasks" && exit 1
158 if [ "$tasks" -eq $stop_on ]; then
159
160 runlevel="$(runlevel ${vps_utmp})"
161 lxc_log "$name runlevel $runlevel"
162
163 case $runlevel in
164 N*)
165 # nothing for new boot state
166 ;;
167 ??0)
168 lxc_log "$name halt"
169 lxc-stop -n "${name}"
170 lxc-wait -n ${name} -s STOPPED
171 break
172 ;;
173 ??6)
174 lxc_log "$name reboot";
175 lxc-stop -n ${name}
176 lxc-wait -n ${name} -s STOPPED
177 lxc-start -d -n ${name} -o /tmp/${name}.log
178 ;;
179 *)
180 # make sure vps is still running
181 state="$(lxc-info -n "${name}" | sed -e 's/.* is //')"
182 [ "$state" = "RUNNING" ] || break
183 ;;
184 esac
185 else
186 lxc_log "$name $tasks tasks $sulogins console"
187 fi
188
189 # time of 5 minutes on it JUST IN CASE...
190 inotifywait -qqt 300 ${vps_utmp}
191 done
192
193 lxc_log "$name watchdog exited"
194
195 }
196
197
198 usage() {
199 echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
200 exit 3
201 }
202
203 command_on_lxc() {
204 command=$1
205 shift
206
207 echo "# $command $1"
208
209 case "$command" in
210
211 start)
212 lxc_exists $1
213 cleanup_init_scripts $1
214 setup_inittab $1 ":respawn:/sbin/getty.*tty1" "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
215 setup_inittab $1 "::power" "p0::powerfail:/sbin/init 0"
216 setup_inittab $1 "::ctrlaltdel" "p6::ctrlaltdel:/sbin/init 6"
217 lxc_start $1
218 # give container 5 seconds to start more than one process
219 ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
220 ;;
221 stop|halt)
222 lxc_exists $1
223 lxc_stop $1
224 ;;
225 reload|force-reload|restart|reboot)
226 lxc_kill $1 -SIGINT
227 ;;
228 watchdog)
229 lxc_watchdog $1
230 ;;
231 boot)
232 echo $1 > /var/lib/lxc/$1/on_boot
233 ;;
234 disable)
235 echo -n > /var/lib/lxc/$1/on_boot
236 ;;
237 *)
238 usage
239 ;;
240
241 esac
242
243 }
244
245 command=$1
246 test -z "$command" && usage
247 test "$command" = "status" && lxc_status && exit
248 shift
249
250 if [ -z "$1" ] ; then
251 ls /var/lib/lxc/*/on_boot | while read path ; do
252 name=`echo $path | cut -d/ -f5`
253 if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
254 command_on_lxc $command $name
255 else
256 echo "# skip $command $name"
257 fi
258 done
259 else
260 while [ ! -z "$1" ] ; do
261 command_on_lxc $command $1
262 shift
263 done
264 fi
265

Properties

Name Value
svn:executable *

  ViewVC Help
Powered by ViewVC 1.1.26